global function map_objects_init
// global function test_cores


void function map_objects_init()
{
    precache_needed_stuff_like_rn()

    AddCallBack_OnSpecificMapLoaded( "mp_glitch", placeGlitchObjects )
    AddCallBack_OnSpecificMapLoaded( "mp_relic02", placeRelicObjects )
    AddCallBack_OnSpecificMapLoaded( "mp_wargames", placeWarGameObjects )
    AddCallBack_OnSpecificMapLoaded( "mp_black_water_canal", placeBlackWaterObjects )
    AddCallBack_OnSpecificMapLoaded( "mp_eden", placeEdenObjects )
    AddCallBack_OnSpecificMapLoaded( "mp_forwardbase_kodai", placeForwardBaseObjects )
}

void function test_cores()
{
    entity titan = CreateNPCTitan( "npc_titan_atlas", 10, GetPlayerByIndex(0).GetOrigin(), <0,0,0>, [] )
    SetSpawnOption_NPCTitan( titan, TITAN_HENCH )
    SetSpawnOption_AISettings( titan, "npc_titan_atlas_stickybomb" )
    // SetSpawnOption_Titanfall( titan )
    SetSpawnOption_Weapon( titan, "mp_titancore_laser_cannon" )
    SetSpawnOption_CoreAbility( titan, "mp_titancore_laser_cannon" )
    DispatchSpawn( titan )
    
    TakeAllWeapons( titan )
    titan.GiveOffhandWeapon( "mp_titancore_laser_cannon", OFFHAND_EQUIPMENT )
	entity soul = titan.GetTitanSoul()
	SoulTitanCore_SetNextAvailableTime( soul, 100.0 )

    wait 2

    entity weapon = titan.GetOffhandWeapon( OFFHAND_EQUIPMENT ) 
    // entity weapon = GetPrimaryWeapons( titan )[0]

    soul.SetCoreUseDuration( 6.0 )

    // titan.SetActiveWeaponBySlot( OFFHAND_EQUIPMENT )

    OnAbilityCharge_LaserCannon( weapon )

    wait 2
    
    OnAbilityChargeEnd_LaserCannon( weapon )
    OnAbilityStart_LaserCannon( weapon )

    CoreChargeBegin( titan, titan, weapon )
    titan.SetBehaviorSelector( "SelectSchedule_TitanCore" )
}